import numpy

#THETA_MAX = 32
#RO_MAX = 50
#RO_MAX = 25

import lsst.afw.image as afwImage
import lsst.afw.display.ds9 as ds9
import hsc.qa as qa

if __name__ == '__main__':

    file = 'CORR-0022374-034.fits'
    exp = afwImage.ExposureF(file)
    mask = exp.getMaskedImage().getMask()
    mask &= mask.getPlaneBitMask("DETECTED")
    mask_arr = mask.getArray()
    mask_arr = numpy.array(mask_arr, dtype=numpy.int32)
    mask = afwImage.ImageI(mask_arr)

#    nAngle = 16
#    nRho = 32
    nAngle = 200
    nRho = 200

#    nAngle = 360 
#    nRho = 4650

    hough = qa.Hough(mask, nAngle, nRho)
#RO_MAX = 25

    #himage, ang, dis =  hough.calcHough()

    himage, ang, dis = hough.calcHough()
#    import pudb;pudb.set_trace()


    a = -1.0 * (numpy.cos(ang)/numpy.sin(ang))
    b = dis / numpy.sin(ang)
####    print "y = %g * x + %g" % (a, b)
    
    himage.writeFits('output.fits')
####    print ang, dis

    xx = numpy.array([0, 2048]) 
    yy = a * xx + b 
    points = numpy.array([(x, y) for (x, y) in zip(xx, yy)])
#    ds9.mtv(himage, frame=0) 
    ds9.mtv(exp.getMaskedImage().getImage(), frame=0) 
    ds9.line(points, frame=0, ctype='cyan')
#    ds9.dot('o', ang, dis, frame=0, size=20, ctype='cyan')

# 151.875 0
 
