import numpy

#THETA_MAX = 32
#RO_MAX = 50
#RO_MAX = 25

import lsst.afw.image as afwImage
import lsst.afw.display.ds9 as ds9
import hsc.qa as qa

if __name__ == '__main__':

    file = 'CORR-0022374-034.fits'
    exp = afwImage.ExposureF(file)
    mask = exp.getMaskedImage().getMask()
    mask &= mask.getPlaneBitMask("DETECTED")
    mask_arr = mask.getArray()
    mask_arr = numpy.array(mask_arr, dtype=numpy.int32)
    mask = afwImage.ImageI(mask_arr)

#    nAngle = 16
#    nRho = 32
    nAngle = 200
    nRho = 200

#    nAngle = 360 
#    nRho = 4650

    hough = qa.Hough(mask, nAngle, nRho)
#RO_MAX = 25

    #himage, ang, dis =  hough.calcHough()

    himage, ang, dis = hough.calcHough()
#    import pudb;pudb.set_trace()


    a = -1.0 * (numpy.cos(ang)/numpy.sin(ang))
    b = dis / numpy.sin(ang)
####    print "y = %g * x + %g" % (a, b)
    
    himage.writeFits('output.fits')
####    print ang, dis

    vHough = himage.getArray()

    ind = numpy.where(vHough > 15000)
    yInd = ind[0] # y coord in hough. sorted in y 
    xInd = ind[1] # x coord in hough. sorted in y 
    nCand = len(yInd)

    vHoughCand = vHough[yInd, xInd]
    indSorted = numpy.argsort(vHoughCand)
    xInd = list(xInd[indSorted])
    xInd = numpy.array(xInd.reverse())
    import pudb;pudb.set_trace()
    yInd = list(yInd[indSorted])
    yInd = numpy.array(yInd.reverse())

    print 'candiates before filtering:', nCand

    xPrev = 0.0
    yPrev = 0.0
    xCandList = numpy.array([])
    yCandList = numpy.array([])
    for (x, y) in zip(xInd, yInd):
        if numpy.hypot(x - xPrev, y - yPrev) > 10.0:
            xCandList = numpy.append(xCandList, x)
            yCandList = numpy.append(yCandList, y)
        xPrev = x
        yPrev = y

#    import pudb;pudb.set_trace()

    nCand = len(xCandList) 
    print 'candiates after filtering:', nCand


    nxImg, nyImg = exp.getMaskedImage().getImage().getDimensions()
    nxHough, nyHough = himage.getDimensions()
    anglePeakList = numpy.pi * xCandList / nAngle
    rhoPeakList = (yCandList - float(nRho)) * int(numpy.hypot(nxImg-1, nyImg-1) + 1) / float(nRho)

    aList = -1.0 * (numpy.cos(anglePeakList)/numpy.sin(anglePeakList))
    bList = rhoPeakList / numpy.sin(anglePeakList)

    # display the result on ds9
    ds9.mtv(exp.getMaskedImage().getImage(), frame=0) 
    for (a, b) in zip(aList, bList):
        xx = numpy.array([0, 2048]) 
        yy = a * xx + b 
        points = numpy.array([(x, y) for (x, y) in zip(xx, yy)])
   #    ds9.mtv(himage, frame=0) 
        ds9.line(points, frame=0, ctype='cyan')
   #    ds9.dot('o', ang, dis, frame=0, size=20, ctype='cyan')

# 151.875 0
 
