import numpy, sys 

#THETA_MAX = 32
#RO_MAX = 50
#RO_MAX = 25

import lsst.afw.image as afwImage
import lsst.afw.display.ds9 as ds9
import hsc.qa as qa

if __name__ == '__main__':

#    file = 'CORR-0022374-034.fits'
#    file = 'CORR-0013200-090.fits'
    file = 'CORR-0013200-091.fits'
#    file = 'CORR-0013200-096.fits'
#    file = 'CORR-0013200-097.fits' # many lines are detected
#    file = 'CORR-0013203-098.fits'
#    file = 'CORR-0013202-099.fits'

#    nAngle = 16
#    nRho = 32
###    nAngle = 200
###    nRho = 200

    if False: # precise version
        houghLimit = 15000
        rMargin = 20.0
        nAngle = 1000
        nRho = 1000

    if True: # experiment
#        houghLimit = 10000
        houghLimit = 7000
#        houghLimit = 8000
        minPixels = 10
        allowedPeakRatio = 1.5 # 2nd and lower peaks should be higher than (1st peak / allowedPeakRatio)
        rMargin = 60
        nAngle = 500
        nRho = 500

#    nAngle = 360 
#    nRho = 4650


    exp = afwImage.ExposureF(file)
    mask = exp.getMaskedImage().getMask()

    goodMask = mask.getPlaneBitMask("DETECTED")
    badMask = mask.getPlaneBitMask(["NO_DATA", "EDGE", "SAT", "SUSPECT", "INTRP", "BAD"])

#    print badMask
#    mask ^= badMask
#    ds9._mtv(mask, None, 'mask', isMask=False)
#    import pudb;pudb.set_trace()

    print goodMask, badMask
#    goodMask = ~badMask
#    mask &= goodMask
#    badMask = (mask.getPlaneBitMask("NO_DATA"))
#    goodMask ^= badMask
#    ds9._mtv(mask, None, 'mask', isMask=False)

    mask_arr = mask.getArray()
    mask_arr = numpy.array(mask_arr, dtype=numpy.int32)
    mask = afwImage.ImageI(mask_arr)

    nxImg, nyImg = exp.getMaskedImage().getImage().getDimensions()



    hough = qa.Hough(mask, nAngle, nRho)
#RO_MAX = 25

    #himage, ang, dis =  hough.calcHough()

    himage, ang, dis = hough.calcHough(goodMask, badMask)
#    import pudb;pudb.set_trace()


    a = -1.0 * (numpy.cos(ang)/numpy.sin(ang))
    b = dis / numpy.sin(ang)
####    print "y = %g * x + %g" % (a, b)
    
    himage.writeFits('output.fits')
####    print ang, dis

    vHough = himage.getArray()
    nyHough, nxHough = vHough.shape
    print nxHough, nyHough

    # convert hough to 1d array 
    vHough1d = numpy.reshape(vHough, nxHough * nyHough )
    x1dInd = numpy.array( [range(nxHough)] * nyHough, dtype=numpy.int32 )
    y1dInd = numpy.array( [ [y] * nxHough for y in range(nyHough) ], dtype=numpy.int32 )
    x1dInd = numpy.reshape(x1dInd, nxHough * nyHough )
    y1dInd = numpy.reshape(y1dInd, nxHough * nyHough )

    # pick out only high hough pixels
    nCand = len(vHough1d)

    print 'candiates before filtering:', nCand
    if False:
        indHigh = numpy.where(vHough1d > houghLimit)
    else: # workaround
        indHigh = numpy.logical_and(vHough1d > houghLimit, y1dInd != 500)
        vHough1dHigh = vHough1d[indHigh]
        x1dIndHigh = x1dInd[indHigh]
        y1dIndHigh = y1dInd[indHigh]

    # grouping high hough-pixel knots, 
    #   assigning one pixel for each knot group by taking the highest hough value in a knot
    ind1dHighSorted = numpy.argsort(vHough1dHigh)
    #   revert to make it descending
    ind1dHighSorted = ind1dHighSorted[-1::-1]
    vHough1dHighSorted = vHough1dHigh[ind1dHighSorted]
    x1dIndHighSorted = x1dIndHigh[ind1dHighSorted]
    y1dIndHighSorted = y1dIndHigh[ind1dHighSorted]

    # further limit pixels by the hough's peak ratio
    maxPeak = vHough1dHighSorted[0]
    minPeak = maxPeak / allowedPeakRatio
    if False:
#    if allowedPeakRatio > 1:
        indLim = numpy.where(vHough1dHighSorted > (peakMax/allowedPeakRatio))
        vHough1dFiltered = vHough1dHighSorted[indLim]
        x1dIndFiltered = x1dIndHighSorted[indLim]
        y1dIndFiltered = y1dIndHighSorted[indLim]
    else:
        vHough1dFiltered = vHough1dHighSorted
        x1dIndFiltered = x1dIndHighSorted
        y1dIndFiltered = y1dIndHighSorted

    #   start grouping knots
    xCandList = numpy.array([])
    yCandList = numpy.array([])

    vHoughArr = numpy.copy(vHough1dFiltered)
    xArr = numpy.copy(x1dIndFiltered)
    yArr = numpy.copy(y1dIndFiltered)

    while len(vHoughArr) > 0:
        x0 = xArr[0]
        y0 = yArr[0]
        # exclude hough points which belongs to this knot group 
        nPixelsThisKnot = 0
        peakThisKnot = 0
        indOthers = numpy.array([], dtype = int)
        for i, (x, y, v) in enumerate(zip(xArr, yArr, vHoughArr)):
            if numpy.hypot(x - x0, y - y0) < rMargin:
                peakThisKnot = (v if v > peakThisKnot else peakThisKnot)
                nPixelsThisKnot += 1
            else:
                indOthers = numpy.append(indOthers, i)

        # decide if this group is a significant trail
        if (nPixelsThisKnot >= minPixels) and (peakThisKnot > minPeak):
            xCandList = numpy.append(xCandList, x0)
            yCandList = numpy.append(yCandList, y0)

        xArr = xArr[indOthers]
        yArr = yArr[indOthers]
        vHoughArr = vHoughArr[indOthers]
        
    nCandHigh = len(xCandList)
    print 'candiates after filtering:', nCandHigh


#    nxHough, nyHough = himage.getDimensions()
    anglePeakList = numpy.pi * xCandList / nAngle
    rhoPeakList = (yCandList - float(nRho)) * int(numpy.hypot(nxImg-1, nyImg-1) + 1) / float(nRho)

    aList = -1.0 * (numpy.cos(anglePeakList)/numpy.sin(anglePeakList))
    bList = rhoPeakList / numpy.sin(anglePeakList)

    if True: # debug
        ds9.mtv(himage, frame=0)
        for (t, r) in zip(xCandList, yCandList):
            ds9.dot('o', t, r, frame=0, size=rMargin, ctype='cyan')

        # display the resultant trails on ds9
        ds9.mtv(exp.getMaskedImage().getImage(), frame=1) 
        for (a, b) in zip(aList, bList):
            xx = numpy.array([0, 2048]) 
            yy = a * xx + b 
            points = numpy.array([(x, y) for (x, y) in zip(xx, yy)])
       #    ds9.mtv(himage, frame=0) 
            ds9.line(points, frame=1, ctype='cyan')

# 151.875 0
 
