#if !defined(HSCQ_QA_HOUGH_H)
#define HSCQ_QA_HOUGH_H
#endif

//#include "lsst/pex/exceptions.h"
#include "lsst/afw/image/Image.h"
#include "lsst/afw/image.h"

namespace hsc {
  namespace qa {

    class Hough { 

    public:
      Hough(lsst::afw::image::Image<int> & image, int nAngle, int nRho);
      lsst::afw::image::Image<int>::Ptr calcHough(double* anglePeak, double* rhoPeak, int goodVal, int badVal);
      lsst::afw::image::Image<int>::Ptr calcHough(double* anglePeak, double* rhoPeak, lsst::afw::image::Image<float> & imagePixData, float minImage, float maxImage, int goodVal, int badVal);

      int getNpixEffective(void) {
	return _npixImageEff;
      };

    private:
      lsst::afw::image::Image<int> _image;
      int _nxImage;
      int _nyImage;
      int _nRho;
      int _nAngle;
      int _rhoMax;
      int _nxHough;
      int _nyHough;
      int _npixImageEff;
      lsst::afw::image::Image<int>::Ptr _imageHough;
      void addHough(int x, int y);
      
    };

  }
}

